import React, { useRef, useState, useEffect } from "react";
import TextField from '@mui/material/TextField';
import MenuItem from '@mui/material/MenuItem';
import 'react-confirm-alert/src/react-confirm-alert.css'; // Import css
import Button from '@mui/material/Button';
import axios from "axios";
import { getCookie, setCookie } from 'react-use-cookie';
import { useHistory } from "react-router-dom";
import CheckOut from "./CheckOut";
import { DataGrid, GridToolbar, frFR } from '@mui/x-data-grid';
import "react-draft-wysiwyg/dist/react-draft-wysiwyg.css";
import { Editor } from '@tinymce/tinymce-react';
import parse from 'html-react-parser';
import { FcViewDetails, FcDisapprove } from "react-icons/fc";
import 'react-tooltip/dist/react-tooltip.css'
import { Tooltip } from 'react-tooltip'
import add_plus from "../mysy_img/plus.png";
import excel_icone from "../mysy_img/excel_icone.png";
import participants from "../mysy_img/participants.png";
import fileDownload from 'js-file-download'
import Popup from 'reactjs-popup';
import Autocomplete from '@mui/material/Autocomplete';
import 'reactjs-popup/dist/index.css';
import { FcCancel, FcApproval, FcAcceptDatabase, FcPrint } from "react-icons/fc";
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";
import { format } from 'date-fns'
import moment from "moment";
import InputAdornment from '@mui/material/InputAdornment';
import { AiFillCloseCircle } from "react-icons/ai";
import Box from '@mui/material/Box';
import { Typography, LinearProgress, sliderClasses } from '@mui/material';
import styled from 'styled-components';
import { CiTrash } from "react-icons/ci";
import { MdAddCircleOutline, MdRemoveCircleOutline } from "react-icons/md";
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import { TransitionProps } from '@mui/material/transitions';
import img_loading_spin from "./../mysy_img/mysy_spin_loading.gif";
import { IoAddCircleOutline, IoCloseCircleOutline } from "react-icons/io5";
import { gridClasses } from '@mui/x-data-grid';
import Link from '@mui/material/Link';
import { PiDotsThree } from "react-icons/pi";

const DisplayPartnerUnite_Enseignement = (props) => {
    const history = useHistory();
    const [submenu, setsubmenu] = useState("");
    const [rowss, setRows] = useState([]);
    const [selectionModel, setSelectionModel] = React.useState([]);

    var date_today_90j = new Date();
    date_today_90j.setDate(date_today_90j.getDate() + 90);

    const [p_filtre1, setp_filtre1] = useState("");
    const [p_filtre1_value, setp_filtre1_value] = useState("");

    const [p_filtre2, setp_filtre2] = useState("");
    const [p_filtre2_value, setp_filtre2_value] = useState("");

    const [p_filtre3, setp_filtre3] = useState("");
    const [p_filtre3_value, setp_filtre3_value] = useState();

    const [p_filtre4, setp_filtre4] = useState("");
    const [p_filtre4_value, setp_filtre4_value] = useState();


    const [isLoading, setLoading] = useState();

    const [gridline_id, setgridline_id] = useState("");

    const columns = [
        { field: '_id', headerName: '_id', hide: true },
        { field: 'id', headerName: 'id', hide: true },
        { field: 'code', headerName: 'Code', flex: 1, hide: false, editable: false, renderCell: (params) => <ExpandableCell_50 {...params} />, },
        { field: 'titre', headerName: 'Titre', flex: 1, hide: false, editable: false, renderCell: (params) => <ExpandableCell_50 {...params} />, },
        { field: 'duration_concat', headerName: 'Durée', flex: 1, hide: false, editable: false, renderCell: (params) => <ExpandableCell_50 {...params} />, },
        { field: 'duration', headerName: 'Durée', flex: 1, hide: true, editable: false },
        { field: 'duration_unite', headerName: 'Unit.', flex: 1, hide: true, editable: false },


        {
            field: "delete", headerName: 'Supprimer',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button


                        >
                            <CiTrash />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Information </div>
                                <div className="gest_content">
                                    {' '}

                                    En confirmant cette opération, l'UE sera <i><font color="red"> définitivement supprimée</font></i>. <br />

                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            handleClick_delete(event, cellValues);
                                            //console.log('modal closed ');
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                //console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>


                );
            }
        }

    ]



    function ExpandableCell_50({ value }) {
        const [expanded, setExpanded] = React.useState(false);
    
        return (
          <nav>
            {value && <div style={{ paddingLeft: "5px", paddingRight: "15px", "display": "block", wordBreak: "break-all" }}>
    
              {expanded ? value : String(value).slice(0, 50)}&nbsp;
              {value.length > 50 && (
                // eslint-disable-next-line jsx-a11y/anchor-is-valid
                <Link
                  type="button"
                  component="button"
                  sx={{ fontSize: 'inherit' }}
                  onClick={() => setExpanded(!expanded)}
                >
                  {expanded ? <nav>  <PiDotsThree />Réduire</nav> : <nav> <PiDotsThree />Voir</nav>}
                </Link>
              )}
            </div>}
    
            {!value && <div style={{ paddingLeft: "5px", paddingRight: "15px", "display": "block", wordBreak: "break-all" }}>
              &nbsp;
            </div>
            }
          </nav>
        );
      }
    

    function handleClick_delete(event, cellValues) {

        Delete_Given_UE(cellValues.row._id);
    }

    const [Delete_Given_UE_api, setDelete_Given_UE_api] = useState();
    const [Delete_Given_UE_message, setDelete_Given_UE_message] = useState();
    const [Delete_Given_UE_result, setDelete_Given_UE_result] = useState();
    function Delete_Given_UE(local_ue_id) {


        var form = new FormData();

        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("_id", local_ue_id);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Delete_Given_Unite_Enseignement/";

        axios.post(myurl, form).then(res => {
            //console.log(" In Delete_Given_UE  res.data.status = " + res.data.status);
            //console.log(" In Delete_Given_UE  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setDelete_Given_UE_api("true");
                setDelete_Given_UE_result(res.data.message);
                Getall_Parter_Unite_Enseignement();
                alert(" La mise à jour été correctement faite.")
            }
            else {
                setDelete_Given_UE_api("false");
                setDelete_Given_UE_message(res.data.message);

                alert(res.data.message);

            }

        }).catch((error) => {

            console.warn('Delete_Given_UE : Not good man :( mysearchtext = ' + error);
            setDelete_Given_UE_api("false");
            alert(" Impossible de supprimer l'UE ");
        })
    }

    const myRef = useRef(null)


    const myRef_head = useRef(null);
    const [selected_id, setselected_id] = useState("");

    const [add_one_ue, setadd_one_ue] = useState("");
    const [display_ue, setdisplay_ue] = useState("");
    let [ue_data_edit_mode, setue_data_edit_mode] = useState("0");


    const [Dialog_1_message, setDialog_1_message] = React.useState(false);
    const [Dialog_1_open, setDialog_1_open] = React.useState(false);
    function Dialog_1_handle_change_participant_session(message) {
        setDialog_1_message(message);
        setDialog_1_open(true);
    }

    const Dialog_1_handleClose = () => {
        //alert(" Utiliser le bouton 'fermer' ");
        //setOpen(false);
    };

    const Dialog_1_handleClose_buton = () => {
        setDialog_1_open(false);
    };


    const [Getall_Parter_Unite_Enseignement_api, setGetall_Parter_Unite_Enseignement_api] = useState();
    const [Getall_Parter_Unite_Enseignement_message, setGetall_Parter_Unite_Enseignement_message] = useState();
    const [Getall_Parter_Unite_Enseignement_result, setGetall_Parter_Unite_Enseignement_result] = useState([]);
    function Getall_Parter_Unite_Enseignement(event) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Unite_Enseignement_no_filter/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Parter_Unite_Enseignement  res.data.status = " + res.data.status);
                //console.log(" In Getall_Parter_Unite_Enseignement  res.data.message r_class = " + res.data.message);
                setGetall_Parter_Unite_Enseignement_api("true");
                setGetall_Parter_Unite_Enseignement_result(res.data.message);
                setRows(res.data.message);
            }
            else {
                setGetall_Parter_Unite_Enseignement_api("false");
                setGetall_Parter_Unite_Enseignement_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Getall_Parter_Unite_Enseignement = ', error);
            setGetall_Parter_Unite_Enseignement_api("false");
            alert(" Impossible de recuperer la liste des unités d'enseignement ");
            //setmyApimyApiMessage("")
        })
    }

    const [Getall_Parter_Unite_Enseignement_with_Filter_api, setGetall_Parter_Unite_Enseignement_with_Filter_api] = useState();
    const [Getall_Parter_Unite_Enseignement_with_Filter_message, setGetall_Parter_Unite_Enseignement_with_Filter_message] = useState();
    const [Getall_Parter_Unite_Enseignement_with_Filter_result, setGetall_Parter_Unite_Enseignement_with_Filter_result] = useState([]);
    function Getall_Parter_Unite_Enseignement_with_Filter(event) {

        var form = new FormData();
        // Recuperation des parametres
        var filtre1 = p_filtre1;
        var filtre2 = p_filtre2;
        var filtre3 = p_filtre3;
        var filtre4 = p_filtre4;

        var filtre1_value = "";
        var filtre2_value = "";
        var filtre3_value = "";
        var filtre4_value = "";
        // Recuperation des valeurs de filtres

        if (p_filtre1_value) {
            filtre1_value = p_filtre1_value;
            form.append(filtre1, filtre1_value);
        }

        if (p_filtre2_value) {
            filtre2_value = p_filtre2_value;
            form.append(filtre2, filtre2_value);
        }

        if (p_filtre3_value) {
            filtre3_value = p_filtre3_value;
            form.append(filtre3, p_filtre3_value);
        }

        if (p_filtre4_value) {
            filtre4_value = p_filtre4_value;
            form.append(filtre4, p_filtre4_value);
        }


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_List_Unite_Enseignement_with_filter/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Getall_Parter_Unite_Enseignement_with_Filter  res.data.status = " + res.data.status);
                //console.log(" In Getall_Parter_Unite_Enseignement_with_Filter  res.data.message r_class = " + res.data.message);
                setGetall_Parter_Unite_Enseignement_with_Filter_api("true");
                setGetall_Parter_Unite_Enseignement_with_Filter_result(res.data.message);
                setRows(res.data.message);
            }
            else {
                setGetall_Parter_Unite_Enseignement_with_Filter_api("false");
                setGetall_Parter_Unite_Enseignement_with_Filter_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Getall_Parter_Unite_Enseignement_with_Filter = ', error);
            setGetall_Parter_Unite_Enseignement_with_Filter_api("false");
            alert(" Impossible de recuperer la liste des unités d'enseignement ");
            //setmyApimyApiMessage("")
        })
    }

    function clean_all_filters() {

        setgridline_id('');

        setp_filtre1("");
        setp_filtre1_value("");

        setp_filtre2("");
        setp_filtre2_value("");

        setp_filtre3("");
        setp_filtre3_value("");

        setp_filtre4("");
        setp_filtre4_value("");


        setSelectionModel([]);

        Getall_Parter_Unite_Enseignement();
    }

    const [Get_Given_Unite_Enseignement_api, setGet_Given_Unite_Enseignement_api] = useState();
    const [Get_Given_Unite_Enseignement_message, setGet_Given_Unite_Enseignement_message] = useState();
    const [Get_Given_Unite_Enseignement_result, setGet_Given_Unite_Enseignement_result] = useState([]);
    function Get_Given_Unite_Enseignement(local_selected_id) {

        var form = new FormData();


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("_id", local_selected_id);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Get_Given_Unite_Enseignement/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) === String("true")) {
                //console.log(" In Get_Given_Unite_Enseignement  res.data.status = " + res.data.status);
                //console.log(" In Get_Given_Unite_Enseignement  res.data.message r_class = " + res.data.message);
                setGet_Given_Unite_Enseignement_api("true");
                setGet_Given_Unite_Enseignement_result(res.data.message);

                var local_ue = JSON.parse(res.data.message);

                if (local_ue.code) {
                    setp_detail_code(local_ue.code);
                } else {
                    setp_detail_code("");
                }

                if (local_ue.titre) {
                    setp_detail_titre(local_ue.titre);
                } else {
                    setp_detail_titre("");
                }

                if (local_ue.support) {
                    setp_detail_support(local_ue.support);
                } else {
                    setp_detail_support("");
                }



                if (local_ue.duration) {
                    setp_detail_duration(local_ue.duration);
                } else {
                    setp_detail_duration("");
                }

                if (local_ue.duration_unite) {
                    setp_detail_duration_unite(local_ue.duration_unite);
                } else {
                    setp_detail_duration_unite("");
                }

                if (local_ue.programme) {
                    setfield_programme(local_ue.programme);
                } else {
                    setfield_programme("");
                }


                if (local_ue.prerequis) {
                    setfield_preprequis(local_ue.prerequis);
                } else {
                    setfield_preprequis("");
                }



                if (local_ue.objectif) {
                    setfield_objectif(local_ue.objectif);
                } else {
                    setfield_objectif("");
                }

                if (local_ue.methode_evaluation) {
                    setfield_suivi_eval(local_ue.methode_evaluation);
                } else {
                    setfield_suivi_eval("");
                }


                if (local_ue.methode_pedagogique) {
                    setfield_methode_pedago(local_ue.methode_pedagogique);
                } else {
                    setfield_methode_pedago("");
                }


                if (local_ue.description) {
                    setfield_description(local_ue.description);
                } else {
                    setfield_description("");
                }



                desable_detail_fields();
            }
            else {
                setGet_Given_Unite_Enseignement_api("false");
                setGet_Given_Unite_Enseignement_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( Get_Given_Unite_Enseignement = ', error);
            setGet_Given_Unite_Enseignement_api("false");
            alert(" Impossible de recuperer les données de l'UE ");
            //setmyApimyApiMessage("")
        })
    }


    const [eu_changed, seteu_changed] = useState("");
    function is_EU_changed() {
        seteu_changed(true);
    }

    const New_duration_unit_list = [
        {
            value: 'heure',
            label: 'Heures',
        },

        {
            value: 'jour',
            label: 'Jours',
        },
        {
            value: 'semaine',
            label: 'Semaines',
        },
        {
            value: 'mois',
            label: 'Mois',
        },
        {
            value: 'user_rythme',
            label: 'Rythme stagiaire',
        },
        {
            value: '',
            label: '',
        }
    ];



    const [enable_editor, setenable_editor] = useState(0);

    function desable_detail_fields() {

        setue_data_edit_mode("0");

        if (document.getElementsByName("code_session") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("code_session")[0].disabled = true;
            document.getElementsByName("code_session")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("titre") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("titre")[0].disabled = true;
            document.getElementsByName("titre")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("description") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("description")[0].disabled = true;
            document.getElementsByName("description")[0].style.backgroundColor = "#ECEFF1";
        }


        if (document.getElementsByName("duree_01") && document.getElementsByName("duree_01")[0]) {
            document.getElementsByName("duree_01")[0].disabled = true;
            document.getElementsByName("duree_01")[0].style.backgroundColor = "#ECEFF1";
        }

        if (document.getElementsByName("unit_duree") && document.getElementsByName("unit_duree")[0]) {
            document.getElementsByName("unit_duree")[0].disabled = true;
            document.getElementsByName("unit_duree")[0].style.backgroundColor = "#ECEFF1";
        }

    }


    function enable_detail_fields() {

        setue_data_edit_mode("1");


        if (document.getElementsByName("code_session") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("code_session")[0].disabled = false;
            document.getElementsByName("code_session")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("titre") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("titre")[0].disabled = false;
            document.getElementsByName("titre")[0].style.backgroundColor = "#FFFFFF";
        }

        if (document.getElementsByName("description") && document.getElementsByName("code_session")[0]) {
            document.getElementsByName("description")[0].disabled = false;
            document.getElementsByName("description")[0].style.backgroundColor = "#FFFFFF";
        }


    }


    useEffect(() => {

        Getall_Parter_Unite_Enseignement();

        if (document.getElementById('myRef_head')) {
            var divh = document.getElementById('myRef_head').offsetTop;
            window.scrollTo({
                top: divh,
                behavior: "smooth",
            });
        }
    }, []);



    function clean_fields() {
        setp_detail_code("");
        setp_detail_titre("");
        setp_detail_support("");
        setp_detail_duration("");
        setp_detail_duration_unite("");
        setfield_methode_pedago("");
        setfield_suivi_eval("");
        setfield_prerequis("");
        setfield_handicap("");
        setfield_description("");
        setfield_objectif("");
        setfield_programme("");
        setfield_preprequis("");

    }

    const [Add_Update_UE_Data_api, setAdd_Update_UE_Data_api] = useState();
    const [Add_Update_UE_Data_message, setAdd_Update_UE_Data_message] = useState();
    const [Add_Update_UE_Data_result, setAdd_Update_UE_Data_result] = useState();
    function Add_Update_UE_Data() {
        setLoading(true);
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");


        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);

        form.append("code", p_detail_code);
        form.append("titre", p_detail_titre);

        form.append("duration", p_detail_duration);
        form.append("duration_unite", p_detail_duration_unite);



        var description = "";
        if (editorRef_description.current) {
            description = editorRef_description.current.getContent();

            if (parse(description.replace(/(<([^>]+)>)/ig, '')).length > editorRef_description_limite) {
                alert(" Champ 'Description', limite depassée !")
                return;
            }
        }

        form.append("description", description);

        var objectif = "";
        if (editorRef_objectif.current) {
            objectif = editorRef_objectif.current.getContent();

            if (parse(objectif.replace(/(<([^>]+)>)/ig, '')).length > editorRef_objectif_limite) {
                alert(" Champ 'Objectif', limite depassée !")
                return;
            }
        }
        form.append("objectif", objectif);


        var prerequis = "";
        if (editorRef_prerequis.current) {
            prerequis = editorRef_prerequis.current.getContent();

            if (parse(prerequis.replace(/(<([^>]+)>)/ig, '')).length > editorRef_prerequis_limite) {
                alert(" Champ 'Pré-requis', limite depassée !")
                return;
            }
        }
        form.append("prerequis", prerequis);


        var programme = "";
        if (editorRef_programme.current) {
            programme = editorRef_programme.current.getContent();

            if (parse(programme.replace(/(<([^>]+)>)/ig, '')).length > editorRef_prerequis_limite) {
                alert(" Champ 'Programme', limite depassée !")
                return;
            }
        }

        form.append("programme", programme);


        var methode_eval = "";
        if (editorRef_methode_eval.current) {
            methode_eval = editorRef_methode_eval.current.getContent();

            if (parse(methode_eval.replace(/(<([^>]+)>)/ig, '')).length > editorRef_methode_eval_limite) {
                alert(" Champ 'Suivi & Evaluation', limite depassée !")
                return;
            }
        }

        form.append("methode_evaluation", methode_eval);


        var methode_pedago = "";
        if (editorRef_programme.current) {
            methode_pedago = editorRef_methode_pedago.current.getContent();

            if (parse(methode_pedago.replace(/(<([^>]+)>)/ig, '')).length > editorRef_methode_eval_limite) {
                alert(" Champ 'Méhode Pédagogique', limite depassée !")
                return;
            }
        }

        form.append("methode_pedagogique", methode_pedago);
        var myurl = ""

        var is_update = 0;

        if (String(display_ue) === "1" && String(add_one_ue) !== "1") {
            form.append("_id", selected_id);
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Update_Unite_Enseignement/";
            is_update = 1;

        } else if (String(display_ue) !== "1" && String(add_one_ue) === "1") {
            myurl = process.env.REACT_APP_API_URL + "myclass/api/Add_Unite_Enseignement/";
        }



        axios.post(myurl, form).then(res => {
            setLoading(false);
            // console.log(" In Add_Update_UE_Data  res.data.status = " + res.data.status);
            //console.log(" In Add_Update_UE_Data  res.data.message r_class = " + res.data.message);

            if (String(res.data.status) === String("true")) {
                setAdd_Update_UE_Data_api("true");
                setAdd_Update_UE_Data_result(res.data.message);
                Getall_Parter_Unite_Enseignement();
                setdisplay_ue("");
                clean_fields();
                alert(res.data.message);


                if (document.getElementById('myRef_head')) {
                    var divh = document.getElementById('myRef_head').offsetTop;
                    window.scrollTo({
                        top: divh,
                        behavior: "smooth",
                    });
                }
            }
            else {
                setAdd_Update_UE_Data_api("false");
                setAdd_Update_UE_Data_message(res.data.message);
                alert(res.data.message);
            }

        }).catch((error) => {
            setLoading(false);
            console.warn('Add_Update_UE_Data : Not good man :( mysearchtext = ' + error);
            setAdd_Update_UE_Data_api("false");
            alert(" Impossible d'ajouter ou  mettre à jour l'UE ");

        })
    }


    function submenu_add_one_UE() {
        clean_fields();
        setdisplay_ue("0");
        setue_data_edit_mode("");
        setadd_one_ue("1");

        if (document.getElementById('myRef')) {
            var divh = document.getElementById('myRef').offsetTop;
            window.scrollTo({
                top: divh,
                behavior: "smooth",
            });
        }
    }

    const [p_detail_code, setp_detail_code] = useState("");
    const [p_detail_titre, setp_detail_titre] = useState("");
    const [p_detail_support, setp_detail_support] = useState("");
    const [p_detail_duration, setp_detail_duration] = useState("");
    const [p_detail_duration_unite, setp_detail_duration_unite] = useState("");


    const editorRef_description = useRef(null);
    const [editorRef_description_limite, seteditorRef_description_limite] = useState(5000);


    const editorRef_objectif = useRef(null);
    const [editorRef_objectif_limite, seteditorRef_objectif_limite] = useState(5000);

    const editorRef_programme = useRef(null);
    const [editorRef_programme_limite, seteditorRef_programme_limite] = useState(5000);

    const editorRef_prerequis = useRef(null);
    const [editorRef_prerequis_limite, seteditorRef_prerequis_limite] = useState(5000);



    const editorRef_methode_pedago = useRef(null);
    const [editorRef_methode_pedago_limite, seteditorRef_methode_pedago] = useState(2000);


    const editorRef_methode_eval = useRef(null);
    const [editorRef_methode_eval_limite, seteditorRef_methode_eval_limite] = useState(2000);


    const [field_description, setfield_description] = useState("");
    const [field_objectif, setfield_objectif] = useState("");
    const [field_programme, setfield_programme] = useState("");
    const [field_preprequis, setfield_preprequis] = useState("");

    const [field_methode_pedago, setfield_methode_pedago] = useState("");
    const [field_suivi_eval, setfield_suivi_eval] = useState("");


    const [field_prerequis, setfield_prerequis] = useState("");

    const [field_handicap, setfield_handicap] = useState("");


    const [editor_tochange, seteditor_tochange] = useState("");
    function editor_keyup() {
        seteditor_tochange("1");
    }


    function Annule_change_data() {
        Get_Given_Unite_Enseignement(selected_id);
        desable_detail_fields();
    }

    function handleClick_edit_ue_From_Line(selected_row_id) {


        var line = JSON.parse(Getall_Parter_Unite_Enseignement_result[selected_row_id]);

        setadd_one_ue("0");
        clean_fields();
        setue_data_edit_mode("");
        setdisplay_ue("1");


        var invoice_id = line._id;
        setselected_id(invoice_id);

        Get_Given_Unite_Enseignement(line._id);

        if (document.getElementById('myRef')) {
            var divh = document.getElementById('myRef').offsetTop;
            window.scrollTo({
                top: divh,
                behavior: "smooth",
            });
        }

    }

    function Annule_add_new_UE() {
        clean_fields();
        setdisplay_ue("0");
        setue_data_edit_mode("");
        setadd_one_ue("");
    }

    const New_Option_Filter = [
        { "id": "titre", "label": "Titre ", "value": "titre" },
        { "id": "code", "label": "Code", "value": "code" },
        { "id": "", "label": "", "value": "" },
        { "id": "1", "label": "", "value": "1" }, // Cette ligne pour couvrir l'ajout d'une ligne de filter. C'est fait expres.
    ]


    return (
        <div className="displayPartnerunite_enseignement">
            {isLoading && <div className="loader-container">
                <div className="mysy_spinner">  <img src={img_loading_spin} />  </div>
            </div>}

            <Dialog
                open={Dialog_1_open}
                onClose={Dialog_1_handleClose}

            >

                <DialogTitle>MySy Information</DialogTitle>
                <DialogContent>
                    <DialogContentText>
                        {Dialog_1_message}
                    </DialogContentText>

                </DialogContent>

                <DialogActions>
                    <Button onClick={Dialog_1_handleClose_buton}>OK</Button>

                </DialogActions>
            </Dialog>

            <h3> Gestion des Unités d'enseignement </h3>
            <div className="div_row">
                <div className="titre1">  Utilisez les filtres !</div>
                <div className="div_row" style={{ "marginBottom": "5px" }}>
                    <div className="div_row_gauche texte_area_filter" >

                        {New_Option_Filter && New_Option_Filter.length > 0 && <Autocomplete
                            disablePortal
                            name="filtre1"
                            id="filtre1"
                            className="disabled_style"
                            value={New_Option_Filter.filter((data) => (data).value === String(p_filtre1))[0].label}
                            options={New_Option_Filter}
                            onChange={(event, value) => {
                                if (value && value.value) {
                                    setp_filtre1(value.value);

                                }

                            }}

                            renderInput={(params) => <TextField {...params} label="" placeholder="Choisir une option"
                                inputProps={{ ...params.inputProps, style: { fontSize: 12, height: "1.4rem" } }}

                            />
                            }
                        />}


                    </div>



                    <div className="div_row_droite texte_area_filter_value" >
                        {p_filtre1 &&
                            <TextField
                                sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                required
                                name="filtre1_value"
                                id="filtre1_value"

                                InputLabelProps={{
                                    shrink: true,
                                }}
                                disabled={false}
                                className="disabled_style"
                                value={p_filtre1_value}
                                onChange={(e) => { setp_filtre1_value(e.target.value); }}
                                InputProps={{
                                    endAdornment: (
                                        <InputAdornment position="end">
                                            <AiFillCloseCircle
                                                style={{ 'cursor': "pointer", "color": "orangered" }}
                                                onClick={(e) => {
                                                    setp_filtre1_value("");
                                                }} />
                                        </InputAdornment>
                                    ),
                                }}

                            />

                        }
                    </div>
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip className="tooltip_css" id="my-tooltip01" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip01" data-tooltip-html="Ajouter une nouvelle ligne de filtre">
                            &nbsp; <MdAddCircleOutline onClick={(e) => {
                                setp_filtre2("1");
                                setp_filtre2_value("");
                            }} />
                        </a>
                    </div>}
                    {p_filtre1 && <div className='filter_bton_add'>
                        <Tooltip className="tooltip_css" id="my-tooltip02" style={{ "fontSize": "12px" }} />
                        <a data-tooltip-id="my-tooltip02" data-tooltip-html="Supprimer cette ligne de filtre">
                            &nbsp; <MdRemoveCircleOutline onClick={(e) => {
                                setp_filtre1("");
                                setp_filtre1_value("");
                            }}
                            />
                        </a>
                    </div>}


                </div>

                {p_filtre2 &&
                    <div className="div_row" style={{ "marginBottom": "5px" }}>
                        <div className="div_row_gauche texte_area_filter">

                            {New_Option_Filter && New_Option_Filter.length > 0 && <Autocomplete
                                disablePortal
                                name="filtre2"
                                id="filtre2"
                                className="disabled_style"
                                value={New_Option_Filter.filter((data) => (data).value === String(p_filtre2))[0].label}
                                options={New_Option_Filter}
                                onChange={(event, value) => {
                                    if (value && value.value) {
                                        setp_filtre2(value.value);

                                    }

                                }}

                                renderInput={(params) => <TextField {...params} label="" placeholder="Choisir une option"
                                    inputProps={{ ...params.inputProps, style: { fontSize: 12, height: "1.4rem" } }}

                                />
                                }
                            />}


                        </div>
                        <div className="div_row_droite texte_area_filter_value" style={{ "marginTop": "0.5rem" }}>
                            {String(p_filtre2).length > 2 &&
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="filtre2_value"
                                    id="filtre2_value"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_filtre2_value}
                                    onChange={(e) => setp_filtre2_value(e.target.value)}
                                    InputProps={{
                                        endAdornment: (
                                            <InputAdornment position="end">
                                                <AiFillCloseCircle
                                                    style={{ 'cursor': "pointer", "color": "orangered" }}
                                                    onClick={(e) => {
                                                        setp_filtre2_value("");
                                                    }} />
                                            </InputAdornment>
                                        ),
                                    }}

                                />}
                        </div>

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add' >
                            <Tooltip className="tooltip_css" id="my-tooltip03" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip03" data-tooltip-html="Ajouter une nouvelle ligne de filtre">
                                &nbsp; <MdAddCircleOutline
                                    onClick={(e) => {
                                        setp_filtre3("1");
                                        setp_filtre3_value("");
                                    }}
                                />
                            </a>
                        </div>}

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add'>
                            <Tooltip className="tooltip_css" id="my-tooltip04" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip04" data-tooltip-html="Supprimer cette ligne de filtre">
                                &nbsp; <MdRemoveCircleOutline
                                    onClick={(e) => {
                                        setp_filtre2("");
                                        setp_filtre2_value("");
                                    }}
                                />
                            </a>
                        </div>}

                    </div>
                }


                {p_filtre3 &&
                    <div className="div_row" style={{ "marginBottom": "5px" }}>
                        <div className="div_row_gauche texte_area_filter">

                            {New_Option_Filter && New_Option_Filter.length > 0 && <Autocomplete
                                disablePortal
                                name="filtre3"
                                id="filtre3"
                                className="disabled_style"
                                value={New_Option_Filter.filter((data) => (data).value === String(p_filtre3))[0].label}
                                options={New_Option_Filter}
                                onChange={(event, value) => {
                                    if (value && value.value) {
                                        setp_filtre3(value.value);

                                    }

                                }}

                                renderInput={(params) => <TextField {...params} label="" placeholder="Choisir une option"
                                    inputProps={{ ...params.inputProps, style: { fontSize: 12, height: "1.4rem" } }}

                                />
                                }
                            />}


                        </div>
                        <div className="div_row_droite texte_area_filter_value" style={{ "marginTop": "0.5rem" }}>
                            {String(p_filtre3).length > 2 &&
                                <TextField
                                    sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                    required
                                    name="filtre3_value"
                                    id="filtre3_value"

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_filtre3_value}
                                    onChange={(e) => setp_filtre3_value(e.target.value)}
                                    InputProps={{
                                        endAdornment: (
                                            <InputAdornment position="end">
                                                <AiFillCloseCircle
                                                    style={{ 'cursor': "pointer", "color": "orangered" }}
                                                    onClick={(e) => {
                                                        setp_filtre3_value("");
                                                    }} />
                                            </InputAdornment>
                                        ),
                                    }}

                                />}
                        </div>

                        {String(p_filtre2).length > 2 && <div className='filter_bton_add' >
                            <Tooltip className="tooltip_css" id="my-tooltip03" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip03" data-tooltip-html="Ajouter une nouvelle ligne de filtre">
                                &nbsp; <MdAddCircleOutline
                                    onClick={(e) => {
                                        setp_filtre4("1");
                                        setp_filtre4_value("");
                                    }}
                                />
                            </a>
                        </div>}

                        {String(p_filtre3).length > 2 && <div className='filter_bton_add'>
                            <Tooltip className="tooltip_css" id="my-tooltip05" style={{ "fontSize": "12px" }} />
                            <a data-tooltip-id="my-tooltip05" data-tooltip-html="Supprimer cette ligne de filtre">
                                &nbsp; <MdRemoveCircleOutline onClick={(e) => {
                                    setp_filtre3("");
                                    setp_filtre3_value("");
                                }} />
                            </a>
                        </div>}
                    </div>
                }


                <div className="div_row" ref={myRef_head} id="myRef_head" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                    <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>
                        <Button variant="contained" className="bton_enreg" onClick={Getall_Parter_Unite_Enseignement_with_Filter}>Rechercher
                        </Button>
                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                        <Button variant="contained" className="bton_annule" onClick={clean_all_filters}>Annuler
                        </Button>

                    </div>

                </div>

                <br />
            </div>



            <div className="div_row">
                <div className="session_data">
                    <div style={{ "border": "None" }}>

                        <div style={{ height: 550, width: '100%', paddingRight: '5px' }}>
                            &nbsp;
                            <Box
                                sx={{
                                    height: 500,
                                    width: '100%',
                                    paddingRight: '1px',



                                    "& .MuiDataGrid-columnHeaders": {
                                        backgroundColor: "#c8cfd5",
                                        color: "black",
                                        fontSize: 14
                                    },


                                    '& .line--statut--selected': {
                                        backgroundColor: '#FBF2EF',
                                        color: 'black',
                                    },
                                    '& .line--statut--pair': {
                                        backgroundColor: 'rgba(235, 235, 235, .7)',
                                        color: 'black',
                                    },
                                    '& .line--statut--impair': {
                                        backgroundColor: '#FFFFFF',
                                        color: 'black',
                                    }, [`& .${gridClasses.cell}`]: {
                                        py: 1,
                                    },


                                }}
                            >
                                <DataGrid
                                    checkboxSelection
                                    onSelectionModelChange={(newSelectionModel) => {
                                        setSelectionModel(newSelectionModel);
                                        /* if (newSelectionModel.length === 1)
                                             handleClick_edit_config_From_Line(newSelectionModel);
                                         if (newSelectionModel.length !== 1) {
                                             setp_detail_config_valeur();
                                             setp_detail_config_point();
                                             setConfig_data_changed();
                                             setconfig_data_edit_mode();
                                             setdisplay_detail_config();
 
 
                                         }*/
                                    }}
                                    selectionModel={selectionModel}
                                    disableSelectionOnClick
                                    localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                    rows={rowss.map((item, index) => (
                                        {
                                            id: index,
                                            _id: JSON.parse(item)._id,
                                            code: JSON.parse(item).code,
                                            titre: JSON.parse(item).titre,
                                            duration_concat: JSON.parse(item).duration_concat,
                                            duration: JSON.parse(item).duration_concat,
                                            duration_unite: JSON.parse(item).duration_unite,

                                        }
                                    ))}

                                    columns={columns}
                                    pageSize={10}
                                    className="datagridclass"

                                    onRowDoubleClick={(newSelectionModel) => {
                                        // handleClick_edit_config_From_Line(newSelectionModel.row.id);

                                        setselected_id(newSelectionModel.row._id);
                                        handleClick_edit_ue_From_Line(newSelectionModel.row.id);

                                    }}

                                    rowsPerPageOptions={[10]}
                                    //disableSelectionOnClick
                                    components={{
                                        Toolbar: GridToolbar,
                                    }}
                                    //sx={datagridSx}
                                    getCellClassName={(params) => {


                                        //field === "order_header_status"
                                        if (params.field === "order_header_status" && String(params.value) == "0") {
                                            return 'cell--status--brouillon';
                                        }

                                        if (params.field === "order_header_status" && String(params.value) == "1") {

                                            return 'cell--status--encours';
                                        }

                                        if (params.field === "order_header_status" && String(params.value) == "2") {
                                            return 'cell--status--traite';
                                        }

                                        if (params.field === "order_header_status" && String(params.value) == "3") {
                                            return 'cell--status--facture';
                                        }

                                    }}
                                    getRowClassName={(params) => {

                                        // Pour la gestion de la couleur de zone double cliquée
                                        if (String(params.row.id) === String(gridline_id)) {

                                            return 'line--statut--selected';
                                        }
                                        else if (parseInt(String(params.row.id)) % 2 === 0) {
                                            return 'line--statut--pair';
                                        }
                                        else if (parseInt(String(params.row.id)) % 2 !== 0) {
                                            return 'line--statut--impair';
                                        }
                                    }}


                                />
                            </Box>
                            <br />

                        </div>

                    </div>

                </div>
                <div className="div_row" style={{ "border": "None" }}>

                    <div className="div_row_gauche div_row_gauche_etendu" style={{ "textAlign": "left", "paddingLeft": "5px" }}>
                        <Button variant="outlined" onClick={submenu_add_one_UE}
                            className="detail_class_submenu bton_add_session"
                            id='menu_import_participant' name='menu_import_participant'>Ajout 1 UE &nbsp;
                            <IoAddCircleOutline style={{ "fontSize": "x-large", "color": "green" }} />
                        </Button>
                    </div>
                </div>

            </div>

            <div className="div_row" ref={myRef} id="myRef"> &nbsp;</div>


            {/*** Affichage d'une UE */}
            {display_ue && String(display_ue) === "1" && String(add_one_ue) !== "1" &&
                <div className="session_data" onChange={is_EU_changed}>
                  

                    <div className="session_caract"><b> Code </b><br />
                        <TextField
                            sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                            required
                            name="code_session"
                            id="code_session"

                            InputLabelProps={{
                                shrink: true,
                            }}
                            //disabled={true}
                            className="disabled_style"
                            value={p_detail_code}
                            onChange={(e) => setp_detail_code(e.target.value)}

                        />
                    </div>

                    <div className="session_caract"><b> Titre </b><br />
                        <TextField
                            sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                            required
                            name="titre"
                            id="titre"

                            InputLabelProps={{
                                shrink: true,
                            }}
                            //disabled={true}
                            className="disabled_style"
                            value={p_detail_titre}
                            onChange={(e) => setp_detail_titre(e.target.value)}

                        />
                    </div>

                    {ue_data_edit_mode && String(ue_data_edit_mode) !== "1" && <div>
                        <div className="session_caract"> Durée <br />
                            <TextField
                                sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                required
                                name="duree_01"
                                id="duree_01"

                                InputLabelProps={{
                                    shrink: true,
                                }}
                                //disabled={true}
                                className="disabled_style"
                                value={p_detail_duration}


                            />
                        </div>

                        <div className="session_caract"> Unité Durée <br />
                            <TextField
                                sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                required
                                name="unit_duree"
                                id="unit_duree"

                                InputLabelProps={{
                                    shrink: true,
                                }}
                                //disabled={true}
                                className="disabled_style"
                                value={p_detail_duration_unite}


                            />
                        </div>


                    </div>}

                    {ue_data_edit_mode && String(ue_data_edit_mode) === "1" &&
                        <div>
                            <div className="session_caract"> Durée <br />

                                <TextField

                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={false}
                                    className="disabled_style"
                                    value={p_detail_duration}
                                    type="number"
                                    onChange={(e) => {
                                        setp_detail_duration(e.target.value);
                                    }
                                    }
                                />
                            </div>

                            <div className="session_caract"> Unité <br />
                                <Tooltip className="tooltip_css" id="my-tooltip11" />
                                <a data-tooltip-id="my-tooltip11" data-tooltip-html="Les durée autorisées sont : 'heure', 'jour', 'semaine', 'mois', 'annee', 'rythme participant'">

                                    <Autocomplete
                                        disablePortal

                                        className="disabled_style"
                                        options={New_duration_unit_list}

                                        value={New_duration_unit_list.filter((data) => (data).value === String(p_detail_duration_unite))[0].label}

                                        onChange={(event, value) => {
                                            if (value && value.value) {
                                                setp_detail_duration_unite(value.value);
                                                seteu_changed();
                                            }
                                        }}

                                        renderInput={(params) => <TextField {...params} label="" />
                                        }
                                    />
                                </a>
                            </div>
                        </div>}
                    {ue_data_edit_mode && String(ue_data_edit_mode) === "1" &&
                        <div className="div_row">

                            <div className="training_data">


                                <div className="training_text" style={{border:"1px solid"}} >
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Pré-requis  (max 1000 caractères) </div>
                                        <Editor
                                            name="prerequis"
                                            id="prerequis"
                                            onInit={(evt, editor) => editorRef_prerequis.current = editor}
                                            initialValue={field_preprequis}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {

                                                if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed()
                                                    seteditor_tochange("");
                                                }
                                            }}

                                            init={{
                                                resize: false,
                                                height: 300,
                                                readonly: 1,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',


                                            }}
                                        />

                                    </div>
                                </div>


                                <div className="training_text">
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Description  (max 1000 caractères) </div>
                                        <Editor
                                            name="description"
                                            id="description"
                                            onInit={(evt, editor) => editorRef_description.current = editor}
                                            initialValue={field_description}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {

                                                if (String(editor_tochange) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed()
                                                    seteditor_tochange("");
                                                }
                                            }}

                                            init={{
                                                resize: false,
                                                height: 300,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }'
                                            }}
                                        />

                                    </div>
                                </div>

                                <div className="training_text"  style= {{border:"1px solid"}} >
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Objectif (max 1000 caractères) </div>
                                        <Editor
                                            onInit={(evt, editor) => editorRef_objectif.current = editor}
                                            initialValue={field_objectif}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {
                                                if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed();
                                                    seteditor_tochange("");
                                                }
                                            }}
                                            init={{
                                                resize: false,
                                                height: 300,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }'
                                            }}
                                        />

                                    </div>
                                </div>


                                <div className="training_text">
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Programme (max 1000 caractères) </div>
                                        <Editor
                                            onInit={(evt, editor) => editorRef_programme.current = editor}

                                            initialValue={field_programme}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {
                                                if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed();
                                                    seteditor_tochange("");
                                                }
                                            }}
                                            init={{
                                                resize: false,

                                                height: 300,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                            }}
                                        />

                                    </div>
                                </div>

                                <div className="training_text">
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Suivi & Evaluation (max 1000 caractères) </div>
                                        <Editor
                                            onInit={(evt, editor) => editorRef_methode_eval.current = editor}

                                            initialValue={field_suivi_eval}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {
                                                if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed();
                                                    seteditor_tochange("");
                                                }
                                            }}
                                            init={{
                                                resize: false,

                                                height: 300,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                            }}
                                        />

                                    </div>
                                </div>


                                <div className="training_text">
                                    <div className="plus_produit_desabled">
                                        <div className="titre_training_text"> Méthode Pédagogique </div>
                                        <Editor
                                            onInit={(evt, editor) => editorRef_methode_pedago.current = editor}

                                            initialValue={field_methode_pedago}
                                            onKeyUp={editor_keyup}
                                            onEditorChange={(newValue, editor) => {
                                                if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                                    //alert(" change");
                                                    is_EU_changed();
                                                    seteditor_tochange("");
                                                }
                                            }}
                                            init={{
                                                resize: false,

                                                height: 300,
                                                menubar: false,
                                                plugins: [
                                                    'advlist autolink lists link image charmap print preview anchor',
                                                    'searchreplace visualblocks code fullscreen',
                                                    'insertdatetime media table paste code help wordcount'
                                                ],

                                                content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                            }}
                                        />

                                    </div>
                                </div>
                            </div>


                        </div>
                    }

                    {String(ue_data_edit_mode) !== "1" &&
                        <div className="div_row" style={{ padding: "10px" }}>


                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u> Pré-requis :</u></b></div>
                                    {parse(field_preprequis.replace(/(<([^>]+)>)/ig, ''))}
                                </div>
                                <br />
                            </div>

                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u> Desscription :</u></b></div>
                                    {parse(field_description.replace(/(<([^>]+)>)/ig, ''))}

                                </div>
                                <br />
                            </div>

                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u> Objectif : </u></b></div>
                                    {parse(field_objectif.replace(/(<([^>]+)>)/ig, ''))}

                                </div>
                                <br />
                            </div>


                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u> Programme :</u></b></div>

                                    {parse(field_programme.replace(/(<([^>]+)>)/ig, ''))}

                                </div>
                                <br />
                            </div>

                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u> Suivi & Evaluation :</u></b></div>
                                    {parse(field_suivi_eval.replace(/(<([^>]+)>)/ig, ''))} 
                                  

                                </div>
                                <br />
                            </div>


                            <div className="training_text">
                                <div className="plus_produit_desabled">
                                    <div className="titre_training_text"> <b><u>  Méthode Pédagogique :</u></b></div>

                                    {parse(field_methode_pedago.replace(/(<([^>]+)>)/ig, ''))}
                                </div>
                                <br />
                            </div>


                        </div>}


                    {String(ue_data_edit_mode) === "1" && <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                        {eu_changed === "1" &&
                            <div className="div_row">
                                <div className="koUpdateData" style={{ "color": "orange", "textAlign": "center" }}> /!\ Pensez à enregistrer les modifications
                                </div>
                            </div>}

                        <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>

                            <Button variant="contained" className="bton_enreg" onClick={Add_Update_UE_Data}>Enregistrer les modifications
                            </Button>

                        </div>

                        <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }} >
                            <Button variant="contained" className="bton_annule" onClick={Annule_change_data}>Annuler
                            </Button>
                        </div>

                    </div>}


                    {String(ue_data_edit_mode) !== "1" && <div className="div_row" style={{ "textAlign": 'right', 'marginRight': '15px' }}>

                        <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>

                            <Button variant="contained" className="bton_edit" onClick={enable_detail_fields}>Editer
                            </Button>
                        </div>

                    </div>}

                </div>
            }



            {/**** Ajout d'une UE */}
            {display_ue && String(display_ue) !== "1" && String(add_one_ue) === "1" && <div className="session_data" >

                <div className="session_caract"><b> Code </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="code_session"
                        id="code_session"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        //disabled={true}
                        className="disabled_style"
                        value={p_detail_code}
                        onChange={(e) => setp_detail_code(e.target.value)}

                    />
                </div>

                <div className="session_caract"><b> Titre </b><br />
                    <TextField
                        sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                        required
                        name="titre"
                        id="titre"

                        InputLabelProps={{
                            shrink: true,
                        }}
                        //disabled={true}
                        className="disabled_style"
                        value={p_detail_titre}
                        onChange={(e) => setp_detail_titre(e.target.value)}

                    />
                </div>


                <div>
                    <div className="session_caract"> Unité Durée  <br />

                        <TextField

                            InputLabelProps={{
                                shrink: true,
                            }}
                            type="number"
                            disabled={false}
                            className="disabled_style"
                            value={p_detail_duration}
                            onChange={(e) => {
                                setp_detail_duration(e.target.value);
                            }
                            }
                        />
                    </div>

                    <div className="session_caract"> Unité Durée <br />
                        <Tooltip className="tooltip_css" id="my-tooltip11" />
                        <a data-tooltip-id="my-tooltip11" data-tooltip-html="Les durée autorisées sont : 'heure', 'jour', 'semaine', 'mois', 'annee', 'rythme participant'">

                            <Autocomplete
                                disablePortal

                                className="disabled_style"
                                options={New_duration_unit_list}

                                value={New_duration_unit_list.filter((data) => (data).value === String(p_detail_duration_unite))[0].label}

                                onChange={(event, value) => {
                                    if (value && value.value) {
                                        setp_detail_duration_unite(value.value);
                                        seteu_changed();
                                    }
                                }}

                                renderInput={(params) => <TextField {...params} label="" />
                                }
                            />
                        </a>
                    </div>
                </div>

                <div className="div_row">

                    <div className="training_data">


                        <div className="training_text">
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Pré-requis  (max 1000 caractères) </div>
                                <Editor
                                    name="prerequis"
                                    id="prerequis"
                                    onInit={(evt, editor) => editorRef_prerequis.current = editor}
                                    initialValue={field_preprequis}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {

                                        if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                            //alert(" change");
                                            is_EU_changed()
                                            seteditor_tochange("");
                                        }
                                    }}

                                    init={{
                                        resize: false,
                                        height: 300,
                                        readonly: 1,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',


                                    }}
                                />

                            </div>
                        </div>


                        <div className="training_text">
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Description (max 1000 caractères) </div>
                                <Editor
                                    name="description"
                                    id="description"
                                    onInit={(evt, editor) => editorRef_description.current = editor}
                                    initialValue={field_description}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {

                                        if (String(editor_tochange) === "1") {
                                            //alert(" change");
                                            is_EU_changed()
                                            seteditor_tochange("");
                                        }
                                    }}

                                    init={{
                                        resize: false,
                                        height: 300,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }'
                                    }}
                                />

                            </div>
                        </div>

                        <div className="training_text" style= {{border:"1px solid"}}  >
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Objectif (max 1000 caractères) </div>
                                <Editor
                                    onInit={(evt, editor) => editorRef_objectif.current = editor}
                                    initialValue={field_objectif}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {
                                        if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                            //alert(" change");
                                            is_EU_changed();
                                            seteditor_tochange("");
                                        }
                                    }}
                                    init={{
                                        resize: false,
                                        height: 300,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }'
                                    }}
                                />

                            </div>
                        </div>


                        <div className="training_text" style= {{border:"1px solid"}} >
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Programme (max 1000 caractères) </div>
                                <Editor
                                    onInit={(evt, editor) => editorRef_programme.current = editor}

                                    initialValue={field_programme}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {
                                        if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                            //alert(" change");
                                            is_EU_changed();
                                            seteditor_tochange("");
                                        }
                                    }}
                                    init={{
                                        resize: false,

                                        height: 300,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                    }}
                                />

                            </div>
                        </div>

                        <div className="training_text">
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Suivi & Evaluation (max 1000 caractères) </div>
                                <Editor
                                    onInit={(evt, editor) => editorRef_methode_eval.current = editor}

                                    initialValue={field_suivi_eval}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {
                                        if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                            //alert(" change");
                                            is_EU_changed();
                                            seteditor_tochange("");
                                        }
                                    }}
                                    init={{
                                        resize: false,

                                        height: 300,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                    }}
                                />

                            </div>
                        </div>


                        <div className="training_text">
                            <div className="plus_produit_desabled">
                                <div className="titre_training_text"> Méthode Pédagogique </div>
                                <Editor
                                    onInit={(evt, editor) => editorRef_methode_pedago.current = editor}

                                    initialValue={field_methode_pedago}
                                    onKeyUp={editor_keyup}
                                    onEditorChange={(newValue, editor) => {
                                        if (String(editor_tochange) === "1" && String(ue_data_edit_mode) === "1") {
                                            //alert(" change");
                                            is_EU_changed();
                                            seteditor_tochange("");
                                        }
                                    }}
                                    init={{
                                        resize: false,

                                        height: 300,
                                        menubar: false,
                                        plugins: [
                                            'advlist autolink lists link image charmap print preview anchor',
                                            'searchreplace visualblocks code fullscreen',
                                            'insertdatetime media table paste code help wordcount'
                                        ],

                                        content_style: 'body { font-family:Helvetica,Arial,sans-serif; font-size:14px; }',

                                    }}
                                />

                            </div>
                        </div>
                    </div>


                </div>


                <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>


                    <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>

                        <Button variant="contained" className="bton_enreg" onClick={Add_Update_UE_Data}>Enregistrer
                        </Button>

                    </div>

                    <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }} >
                        <Button variant="contained" className="bton_annule" onClick={Annule_add_new_UE}>Annuler
                        </Button>
                    </div>

                </div>


            </div>}


        </div>
    )
}


export default DisplayPartnerUnite_Enseignement;

