import Navigation from "../components/Navigation";
import { Helmet } from "react-helmet";
import bannerimg2 from "../mysy_img/MYSY-LOGO-BLUE.png";
import notrevisionimg from "../mysy_img/notre_vision.png";
import entrepriseimg from "../mysy_img/batiment-3d.png"
import particulierimg from "../mysy_img/particulier.png"
import descriptionimg from "../mysy_img/description.png"
import ousommesnousimg from "../mysy_img/mysy_training_technology_ici.png"
import sloganimg from "../mysy_img/slogan.png"
import GoogleMapReact from 'google-map-react';
import React, { Component } from 'react';
import { withScriptjs, withGoogleMap, GoogleMap, Marker } from "react-google-maps"
import { FacebookShareButton, LinkedinShareButton, TwitterShareButton } from "react-share";
import { SocialIcon } from 'react-social-icons';
import logowhite from "../mysy_img/MYSY-LOGO-WHITE.png";
import Footer from "./Fotter";
import Header from "./Header";
import Button from '@mui/material/Button';
import img_1 from "../mysy_img/1.jpg";
import img_2 from "../mysy_img/2.jpg";
import img_3 from "../mysy_img/3.jpg";


const quisommesnous = () => {

    const MyMapComponent = withScriptjs(withGoogleMap((props) =>
        <GoogleMap

            defaultZoom={18}
            defaultCenter={{ lat: 48.866669, lng: 2.33333 }}
        >
            {props.isMarkerShown && <Marker position={{ lat: 48.866669, lng: 2.33333 }} />}
        </GoogleMap>
    ))

    return (
        <div className="quisommesnous">
            <Helmet>
                <title>MySy Training, qui sommes nous ?</title>
                <meta name="description" content="Nous sommes une base de données uniquement dediée aux formations et tutoriels" />
                <meta name="robots" content="index,follow" />
                <meta name="title" content="Trouver des Formations.Acces libre.Qualité top" />
                <link rel="canonical" href={`${process.env.REACT_APP_BASE_URL}` + "/QuiSommesNous"} />

            </Helmet>
            <Header />

            <div className="div_mobile">

                <div className="div_row_presenation" >

                    <div className="div_row_img1">

                        <img src={img_1} alt="MySy Training Technology" className="img_1" />
                    </div>
                    <div className="div_row_img2">
                        <img src={img_2} alt="MySy Training Technology" className="img_1" />
                    </div>
                    <div className="div_row_img3">
                        <img src={img_3} alt="MySy Training Technology" className="img_1" />
                    </div>

                </div> 
                <div className="div_row_center">
                    <h1 className="div_row_center_text">Forgez la réussite de votre entreprise.</h1>
                    <div className="div_row_center_enphasis" >Stratégie. Organisation. Croissance.</div>
                </div>

                <div className="div_row_center_contact">
                    <Button variant="outlined" onClick={"menu_info"} className="bton_contact_nous"> Contactez-Nous</Button>
                </div>

                <div className="div_row_presenation" >

                    <div className="div_row_line1">
                        <div className="text_head_new">
                            À PROPOS
                        </div>
                        <hr />
                        <div className="text_desc">
                       
                        MySy Training Technology est un moteur de recherche exclusivement dédié à la formation.  Il met le profil de l’utilisateur au cœur du système pour trouver la formation la plus adaptée à sa situation.

                        Des algorithmes spécifiquement conçus pour le monde de la formation nous permettent d’adresser un large éventail de profils.

                        Quelque soit votre situation, ...</div>
                        <br /> <br />
                        <div className="text_desc"> &nbsp;
                        </div>


                    </div>
                    <div className="div_row_line2">
                        <div className="text_head_new">
                            NOTRE VISION
                        </div>
                        <hr />
                        <div className="text_desc">
                        Permettre à chaque personne de trouver la formation qu’il lui faut<br/>
                        Prendre en compte vos contraintes, votre réalité pour vous accompagner dans votre  montée en compétence… réelle et réaliste <br/>
                        Aiguiller les futurs apprenants vers le chemin le plus direct  
                            </div>
                        <br /> <br />
                        <div className="text_desc"> &nbsp;
                        </div>
                    </div>
                    <div className="div_row_line3">
                        <div className="text_head_new">
                            SERVICES
                        </div>
                        <hr />
                        <div className="text_desc">
                            <ul>
                                <li className="myli">
                                    Identifier la formation qu’il vous faut
                                </li>
                                <li className="myli">
                                    Viser au plus juste la réponse au besoin
                                </li>
                                <li className="myli">
                                    Aligner la formation des collaborateurs avec la stratégie de l’entreprise
                                </li>
                                <li className="myli">
                                    Maitriser et piloter votre budget
                                </li>
                               

                            </ul>
                        </div>
                        <br /> <br />
                        <div className="text_desc">&nbsp;
                        </div>
                    </div>

                </div>

                {/*
                <div className="div_row">
                    <div className="nom_prenom"> Description </div>
                    <div className="div_row_gauche">
                        <img class="img-responsive img_gauche_taille" src={descriptionimg} alt="Description MySy training Technology" />
                    </div>

                    <div className="div_row_droite" id="desc" >

                        MySy Training Technology est un moteur de recherche exclusivement dédié à la formation.  Il met le profil de l’utilisateur au cœur du système pour trouver la formation la plus adaptée à sa situation.

                        Des algorithmes spécifiquement conçus pour le monde de la formation nous permettent d’adresser un large éventail de profils.

                        Quelque soit votre situation, que vous soyez malvoyant, mal entendant, tout simplement à la recherche de la formation qui prend en compte vos besoins, le moteur de recherche MySy-T est là pour vous.


                    </div>



                </div>



                <div className="div_row">
                    <div className="nom_prenom"> Notre Vision </div>
                    <div className="div_row_gauche">
                        <img class="img-responsive img_gauche_taille" src={notrevisionimg} alt="Vision MySy Technology" />
                    </div>

                    <div className="div_row_droite" id="vision">


                        <li>
                            Permettre à chaque personne de trouver la formation qu’il lui faut
                        </li>

                        <li>
                            Prendre en compte vos contraintes, votre réalité pour vous accompagner dans votre  montée en compétence… réelle et réaliste
                        </li>

                        <li>
                            Aiguiller les futurs apprenants vers le chemin le plus direct
                        </li>


                    </div>



                </div>


                <div className="div_row">
                    <div className="nom_prenom">Notre devise  </div>
                    <div className="div_row_gauche">
                        <img class="img-responsive img_gauche_taille" src={sloganimg} alt="Slogan MySy Technology" />
                    </div>

                    <div className="div_row_droite">

                        Quel que soit votre situation, que vous soyez malvoyant, mal entendant, le moteur de recherche MySy-T vous trouve la formation qu’il vous faut.

                    </div>
                </div>


                <div className="div_row">
                    <div className="nom_prenom">Nos solution pour les entreprises  </div>
                    <div className="div_row_gauche">
                        <img class="img-responsive" src={entrepriseimg} style={{ maxWidth: '50%' }} />
                    </div>

                    <div className="div_row_droite" >

                        <li>
                            Aligner la formation des collaborateurs avec la stratégie de l’entreprise
                        </li>
                        <li>
                            Maitriser et piloter votre budget
                        </li>
                        <li>
                            Retrouver de la souplesse et de l’autonomie dans le choix et la durée des formations
                        </li>

                    </div>



                </div>


                <div className="div_row">
                    <div className="nom_prenom">Nos solution pour les particuliers   </div>
                    <div className="div_row_gauche">
                        <img class="img-responsive img_gauche_taille" src={particulierimg} />
                    </div>

                    <div className="div_row_droite" >

                        <li>
                            Identifier la formation qu’il vous faut
                        </li>
                        <li>
                            Donner de l’autonomie à l’apprenant
                        </li>
                        <li>
                            Viser au plus juste la réponse au besoin
                        </li>

                    </div>



                </div>
*/}
                <div className="div_row_where">

                    <div className="text_head_new">
                        OU NOUS TROUVER ?
                    </div>

                    <div className="div_carte">
                        <a target="_blank"
                            href="https://www.google.com/maps/place/MySy+Training+Technology/@48.8761591,2.3260624,15z/data=!4m5!3m4!1s0x0:0x8239ba23406c9699!8m2!3d48.8761591!4d2.3260624">
                            <img src={ousommesnousimg} alt="logo MySy Technology ou sommes nous" style={{ 'width': "100%", 'height': '50%' }} />
                        </a>


                    </div>

                    <div className="div_adresse" >
                        <br />
                        <div>MySy Training Technology<br />
                        </div>
                        <div style={{ fontSize: "x-small" }}>

                            Adresse : 1 Cr du Havre, 75008 Paris <br />
                            Adresse email :
                            <a href="mailto: contact@mysy-training.com?subject=Mail from mysy website" target="_blank"> contact@mysy-training.com</a> <br />

                            Téléphone fixe : +331 77 00 38 57<br />
                            Téléphone : +337 69 20 39 45<br />

                        </div>
                        <br />
                        <div> Sur nos reseaux sociaux

                            <div style={{ 'float': "center", "textAlign": "center" }}>
                                <div className="media_sociaux">
                                    <FacebookShareButton
                                        url={"https://www.facebook.com/MySy-Training-114572794561371/"}
                                    >
                                        <SocialIcon network="facebook" className="SocialIcon" />
                                    </FacebookShareButton>
                                    &nbsp;

                                    <TwitterShareButton
                                        url={"https://twitter.com/mysy_training"}
                                        hashtag={"#MySyTraining"}
                                    >
                                        <SocialIcon network="twitter" className="SocialIcon" />
                                    </TwitterShareButton>

                                    &nbsp;
                                    <LinkedinShareButton
                                        url={"https://www.linkedin.com/"}
                                        summary={"ee"}
                                        source={"https://www.linkedin.com/in/mysy-training-96b53a237/"}

                                    >
                                        <SocialIcon network="linkedin" className="SocialIcon" />
                                    </LinkedinShareButton>


                                </div>

                            </div>


                        </div>
                    </div>
                </div>


                <div className="pieddepage">
                    <Footer />
                </div>

            </div>
        </div>

    )
}


export default quisommesnous;
