import Navigation from "./Navigation";
import { Helmet } from "react-helmet";

import ousommesnousimg from "../mysy_img/mysy_training_technology_ici.png"

import React, { Component } from 'react';
import { withScriptjs, withGoogleMap, GoogleMap, Marker } from "react-google-maps"
import { FacebookShareButton, LinkedinShareButton, TwitterShareButton } from "react-share";
import { SocialIcon } from 'react-social-icons';
import logowhite from "../mysy_img/MYSY-LOGO-WHITE.png";
import Footer from "./Fotter";
import Header from "./Header";
import Button from '@mui/material/Button';
import img_1_old from "../mysy_img/1.jpg";
import img_1 from "../mysy_img/gestion_admin.png";
import img_2_old from "../mysy_img/2.jpg";
import img_2 from "../mysy_img/lms.png";
import img_3_old from "../mysy_img/3.jpg";
import img_3 from "../mysy_img/crm.png";
import { Link } from "react-router-dom";
import ReactPlayer from 'react-player/lazy'




const QuiSommesNous_v2 = () => {

    const ButtonMailto = ({ mailto, label }) => {
        return (
            <Link
                to='#'
                onClick={(e) => {
                    window.location.href = mailto;
                    e.preventDefault();
                }}
            >
                <nav className="text_head_new">  {label} </nav>
            </Link>
        );
    };

    const MyMapComponent = withScriptjs(withGoogleMap((props) =>
        <GoogleMap

            defaultZoom={18}
            defaultCenter={{ lat: 48.866669, lng: 2.33333 }}
        >
            {props.isMarkerShown && <Marker position={{ lat: 48.866669, lng: 2.33333 }} />}
        </GoogleMap>
    ))

    return (
        <div className="quisommesnous_v2">
            <Helmet>
                <title>MySy Training, qui sommes nous ?</title>
                <meta name="description" content="éditeur de logiciels pour établissements de formation. Nous proposons des solution de E-Learning, gestion administrative et gestion relation client" />
                <meta name="robots" content="index,follow" />
                <meta name="title" content="Formations.Gestion administrative.E-Learning.CRM" />
                <link rel="canonical" href={`${process.env.REACT_APP_BASE_URL}` + "/QuiSommesNous"} />

            </Helmet>
            <Header />

            <div className="div_mobile" >

                <div className="main_sub_div">

                    <div className="div_row_presenation" >

                        <div className="div_row_img1">
                            <nav className="header_title"> Gestion Adminitrative </nav>

                            <img src={img_1} alt="MySy Training Gestion Administrative" className="img_1" />
                        </div>
                        <div className="div_row_img2">
                            <nav className="header_title"> E-Learning </nav>
                            <img src={img_2} alt="MySy Training E-Learning / LMS" className="img_1" />
                        </div>
                        <div className="div_row_img3">
                            <nav className="header_title"> Relation Client (CRM) </nav>
                            <img src={img_3} alt="MySy Training Gestion relation client" className="img_1" />
                        </div>

                    </div>
                    <div className="div_row"> &nbsp; </div>
                    <div className="div_row_center" style={{ "textAlign": "left" }}>

                        <div className="div_row_center_enphasis" >
                            <b className="chapitre"> Qui sommes nous ? </b> <br />
                            MySy Training est un <b>  éditeur de logiciels </b> dédiés à la gestion des établissements de formation : <i>Instituts de formation, Indépendants, Ecoles, Universités, etc. </i> <br />

                            Nous conseillons, accompagnons nos clients dans <b>la structuration </b>, <b> l’audit </b> et <b> l’organisation </b>de leurs processus et outils.<br />

                            Avec une équipe d’une dizaine de personnes, nous développons des solutions axées sur l’efficacité et le gain de productivité de nos clients, sans oublier la sécurisation de leurs systèmes.<br />
                        </div>
                        <br />
                        <div className="div_row_center_enphasis" >
                            <b className="chapitre"> Hébergement sur nos serveurs (Solution en mode SaaS ) </b> <br />
                            Nous offrons à nos clients la possibilité d’héberger les solutions que nous leur proposons sur nos propres serveurs.  Ils n’ont ainsi rien à gérer. Nos solutions sont disponibles en mode service <a href="https://www.francenum.gouv.fr/guides-et-conseils/pilotage-de-lentreprise/logiciels-de-gestion-de-lentreprise/pourquoi-utiliser-0" target="_blank"> (SaaS) </a> <br />

                        </div>
                        <br />
                        <div className="div_row_center_enphasis" >
                            <b className="chapitre"> Hébergement sur les serveurs du client  </b><br />
                            Pour nos clients qui le souhaitent, nous les accompagnons pour héberger nos solutions sur leurs propres serveurs. Nous les accompagnons tout long de l’installation et la mise en service.<br />

                        </div>
                    </div>
                    <div className="div_row_center" style={{ "border": "None" }}>
                        <hr className="hr_break" />
                    </div>
                    <div className="div_row_center" style={{ "textAlign": "left" }}>

                        <div className="div_row_center_enphasis" >
                            <div className="detail_block" >
                                <div className="detail_text">
                                    <b className="chapitre"> MySy Gestion Administrative  </b> <br /> <br />

                                    Permet de gérer le processus d’inscription des apprenants, les émargements à distance ou en présentiel et les évaluations. Cette solution permet également de gérer les enseignants, le matériel pédagogique, le planning de formation, les agendas, etc.<br />
                                    Elle vous permet également de produire en un clic votre <b><a href="https://travail-emploi.gouv.fr/actualites/l-actualite-du-ministere/article/bilan-pedagogique-et-financier-bpf-organismes-de-formation-c-est-le-moment-de" target="_blank">  Bilan Pédagogique et Financier (BPF)  </a> </b>  <br />
                                    Un intranet intégré permet de publier et de partager les formations sur internet. <br />
                                    Un tableau de bord vous permet de suivre votre activité pédagogique : Taux de remplissage des sessions, répartition par formateur par années, etc.


                                </div>
                                <div className="detail_img">
                                    <img src={img_1} alt="MySy Gestion Administrative" className="img_1" />
                                </div>

                            </div>

                        </div>

                        <div className="div_row_center_enphasis" style={{ "border": "None" }}>
                            <hr className="hr_break" />
                        </div>


                        <div className="div_row_center_enphasis" >
                            <div className="detail_block" >

                                <div className="detail_img">
                                    <img src={img_2} alt="MySy E-Learning / LMS" className="img_1 img_1_bis" />
                                </div>
                                <div className="detail_text">
                                    <b className="chapitre"> MySy E-Learning (LMS)  </b> <br /> <br />

                                    Permet d’avoir votre espace de E-learning, de publier les formations en ligne. A l’aide de son login et mot de passe, chaque apprenant peut suivre la formation en ligne, interagir avec l’enseignant (email, réseaux social). <br />
                                    L’enseignant peut élaborer des travaux dirigés, suivre le temps de réponses des apprenants, corriger les TD. <br />
                                    Un tableau de bord permet de suivre de manière détaillée chaque apprenant.

                                </div>

                            </div>

                        </div>

                        <div className="div_row_center_enphasis" style={{ "border": "None" }}>
                            <hr className="hr_break" />
                        </div>

                        <div className="div_row_center_enphasis" >
                            <div className="detail_block" >
                                <div className="detail_text">
                                    <b className="chapitre"> MySy Gestion relation client  </b> <br /> <br />
                                    Permet de gérer vos clients, les activités en cours, à venir, en retards.
                                    Ce module permet d’éditer, d’envoyer les devis, de les convertir en commande et de les facturer.
                                    Un tableau de bord vous permet de suivre vos revenus en cours, ceux à venir et de prendre les bonnes décisions de gestion

                                </div>
                                <div className="detail_img">
                                    <img src={img_3} alt="MySy Gestion relation client" className="img_1" />
                                </div>

                            </div>

                        </div>

                        <div className="div_row_center_enphasis" style={{ "border": "None" }}>
                            &nbsp;
                        </div>



                    </div>

                    <div className="div_row_center_contact" style={{ width: '100%' }}>
                        <Button variant="outlined" onClick={"menu_info"} className="bton_contact_nous"> Fonctionalités detaillées du Système MySy Training Technology</Button>
                    </div>

                    <div className="div_row_presenation" >

                        <div className="div_row_line1">
                            <div className="text_head_new">
                                Gestion Administrative
                            </div>
                            <hr />
                            <div className="text_desc">

                                <ul>
                                    <li className="myli"> Gestion catalogue formations (intranet / API)</li>
                                    <li className="myli"> Gestion des inscriptions (mise en attente, motif annulation, etc)</li>
                                    <li className="myli"> Gestion des sessions (planifiées, à la demande)</li>
                                    <li className="myli"> Gestion automatique et manuelle des séquences de formations</li>
                                    <li className="myli"> Gestion avis participants</li>
                                    <li className="myli"> Gestion absences</li>
                                    <li className="myli"> Émargement électronique</li>
                                    <li className="myli"> Gestion des employés et du matériel pédagogique</li>
                                    <li className="myli"> Gestion des agendas & réservation de matériel (salles, projecteurs, etc)</li>
                                    <li className="myli"> Tableau de bord de pilotage </li>
                                    <li className="myli"> Intranet intégré pour la publication des formations </li>

                                </ul>

                            </div>
                            <br /> <br />
                            <div className="text_desc"> &nbsp;
                            </div>


                        </div>
                        <div className="div_row_line2">
                            <div className="text_head_new">
                                E-Learning (LMS)
                            </div>
                            <hr />
                            <div className="text_desc">
                                <ul>
                                    <li className="myli"> Hébergement des formations </li>
                                    <li className="myli"> Classe virtuelle </li>
                                    <li className="myli"> Gestion des prérequis </li>
                                    <li className="myli"> Echange enseignants / apprenants </li>
                                    <li className="myli"> Cours en ligne avec exercices </li>
                                    <li className="myli"> Evaluations (notes) </li>
                                    <li className="myli"> Gestion planning </li>
                                    <li className="myli"> Forums de discussion </li>
                                    <li className="myli"> Réseau Social </li>
                                    <li className="myli"> Profil et droit d'accès par utilisateur </li>
                                    <li className="myli"> Export format SCORM </li>
                                </ul>


                            </div>
                            <br /> <br />
                            <div className="text_desc"> &nbsp;
                            </div>
                        </div>
                        <div className="div_row_line3">
                            <div className="text_head_new">
                                Gestion relation client
                            </div>
                            <hr />
                            <div className="text_desc">
                                <ul>
                                    <li className="myli"> Création clients</li>
                                    <li className="myli"> Gestion des différentes contacts client</li>
                                    <li className="myli"> Gestion des activités par collaborateur (tâches en cours, en retards, à venir)</li>
                                    <li className="myli"> Gestion des devis (envoi automatique)</li>
                                    <li className="myli"> Validation automatique des devis</li>
                                    <li className="myli"> Conversion devis en commandes</li>
                                    <li className="myli"> Facturation et envoi automatique</li>
                                    <li className="myli"> Suivi des commandes en cours, des factures à venir</li>
                                    <li className="myli"> Tableau de bord de suivi client </li>
                                </ul>
                            </div>
                            <br /> <br />
                            <div className="text_desc">&nbsp;
                            </div>
                        </div>

                    </div>



                    <div style={{ "width": "100%", "float": "left", "border": "1px solid" }}>
                        <div className="div_row_center_contact" style={{ width: '100%' }}>
                            <Button variant="outlined" onClick={"menu_info"} className="bton_contact_nous"> Découvrez quelques-unes de nos fonctionnalités  </Button>
                        </div>
                        <div className="div_row_center_video_ftion" >
                            <div className="div_row_center_enphasis" >
                                <div className="detail_block_video_ftion">

                                    <div className="detail_text_video_ftion">
                                        <b className="chapitre"> Le catalogue de Formation  </b> <br /> <br />

                                        Import Excel de formation<br />
                                        Creation unitaire<br />
                                        Modification, Suppression, Export, etc<br />


                                    </div>
                                    <div className="detail_img_video_ftion">
                                        <div className="only_mobile">
                                            <b className="chapitre"> Le catalogue de Formation  </b> <br /> <br />

                                            Import Excel de formation<br />
                                            Creation unitaire<br />
                                            Modification, Suppression, Export, etc<br />
                                        </div>
                                        <ReactPlayer
                                            controls={true}
                                            light="https://img.mysy-training.com/video/mysy_catalog_thumb.png"
                                            playing
                                            url='https://img.mysy-training.com/video/MyS_Creation_Catalogue.mp4'
                                            width="100%"
                                        />
                                    </div>


                                </div>

                            </div>
                        </div>

                        <div className="div_row_center_video_ftion" >
                            <div className="div_row_center_enphasis" >
                                <div className="detail_block_video_ftion">

                                    <div className="detail_text_video_ftion">
                                        <b className="chapitre"> Les sessions de Formation  </b> <br /> <br />

                                        Import Excel de formation<br />
                                        Création unitaire<br />
                                        La gestion au quotidien<br />


                                    </div>
                                    <div className="detail_img_video_ftion">
                                        <div className="only_mobile">
                                            <b className="chapitre"> Les sessions de Formation  </b> <br /> <br />

                                            Import Excel de formation<br />
                                            Création unitaire<br />
                                            La gestion au quotidien<br />
                                        </div>
                                        <ReactPlayer
                                            controls={true}
                                            light="https://img.mysy-training.com/video/video_session/mysy_session_thumb.png"
                                            playing
                                            url='https://img.mysy-training.com/video/video_session/MySy_Creation_Session.mp4'
                                            width="100%"
                                        />
                                    </div>


                                </div>

                            </div>
                        </div>

                        <div className="div_row_center_video_ftion" >
                            <div className="div_row_center_enphasis" >
                                <div className="detail_block_video_ftion">

                                    <div className="detail_text_video_ftion">
                                        <b className="chapitre"> Les séquences de Formation  </b> <br /> <br />

                                        Création automatique, manuelle<br />
                                        Ajout de ressources pédagogiques<br />
                                        Réservation Plannings & Agendas<br />


                                    </div>
                                    <div className="detail_img_video_ftion">
                                        <div className="only_mobile">
                                            <b className="chapitre"> Les sessions de Formation  </b> <br /> <br />

                                            Création automatique, manuelle<br />
                                        Ajout de ressources pédagogiques<br />
                                        Réservation Plannings & Agendas<br />
                                        </div>
                                        <ReactPlayer
                                            controls={true}
                                            light="https://img.mysy-training.com/video/video_sequence/mysy_sequence_thumb.png"
                                            playing
                                            url='https://img.mysy-training.com/video/video_sequence/MySy_Creation_Sequences.mp4'
                                            width="100%"
                                        />
                                    </div>


                                </div>

                            </div>
                        </div>
                    </div>



                    <div className="div_row_where">

                        <ButtonMailto label="Contactez-Nous" mailto="mailto:contact@mysy-training.com" className="bton_contact_nous" />
                        <br />


                        <div className="div_carte">
                            <a target="_blank"
                                href="https://www.google.com/maps/place/MySy+Training+Technology/@48.8761591,2.3260624,15z/data=!4m5!3m4!1s0x0:0x8239ba23406c9699!8m2!3d48.8761591!4d2.3260624">
                                <img src={ousommesnousimg} alt="logo MySy Technology ou sommes nous" style={{ 'width': "100%", 'height': '50%' }} />
                            </a>


                        </div>

                        <div className="div_adresse" >
                            <br />
                            <div>MySy Training Technology<br />
                            </div>
                            <div style={{ fontSize: "x-small" }}>

                                Adresse : 1 Cr du Havre, 75008 Paris <br />
                                Adresse email :
                                <a href="mailto: contact@mysy-training.com?subject=Mail from mysy website" target="_blank"> contact@mysy-training.com</a> <br />

                                Téléphone fixe : +331 77 00 38 57<br />
                                Téléphone : +337 69 20 39 45<br />

                            </div>
                            <br />
                            <div> Sur nos reseaux sociaux

                                <div style={{ 'float': "center", "textAlign": "center" }}>
                                    <div className="media_sociaux">
                                        <FacebookShareButton
                                            url={"https://www.facebook.com/MySy-Training-114572794561371/"}
                                        >
                                            <SocialIcon network="facebook" className="SocialIcon" />
                                        </FacebookShareButton>
                                        &nbsp;

                                        <TwitterShareButton
                                            url={"https://twitter.com/mysy_training"}
                                            hashtag={"#MySyTraining"}
                                        >
                                            <SocialIcon network="twitter" className="SocialIcon" />
                                        </TwitterShareButton>

                                        &nbsp;
                                        <LinkedinShareButton
                                            url={"https://www.linkedin.com/"}
                                            summary={"ee"}
                                            source={"https://www.linkedin.com/in/mysy-training-96b53a237/"}

                                        >
                                            <SocialIcon network="linkedin" className="SocialIcon" />
                                        </LinkedinShareButton>


                                    </div>

                                </div>


                            </div>
                        </div>
                    </div>
                </div>

                <div className="pieddepage">
                    <Footer />
                </div>

            </div>
        </div>

    )
}


export default QuiSommesNous_v2;
